import { Point } from './point';
import { ISerializedLineString } from './interface';
/**
 * 线段
 *
 * @author starkewang
 */
export declare class LineString {
    readonly points: Point[];
    /**
     * 初始化
     *
     * @param points    - GeoPoint
     */
    constructor(points: Point[]);
    parse(key: any): {
        [x: number]: {
            type: string;
            coordinates: number[][];
        };
    };
    toJSON(): {
        type: string;
        coordinates: number[][];
    };
    static validate(lineString: ISerializedLineString): boolean;
    static isClosed(lineString: LineString): boolean;
    get _internalType(): import("../utils/symbol").InternalSymbol;
}
