import { Point } from './point';
import { ISerializedMultiPoint } from './interface';
/**
 * 多个 Point
 *
 * @author starkewang
 */
export declare class MultiPoint {
    readonly points: Point[];
    /**
     * 初始化
     *
     * @param points    - GeoPoint
     */
    constructor(points: Point[]);
    parse(key: any): {
        [x: number]: {
            type: string;
            coordinates: number[][];
        };
    };
    toJSON(): {
        type: string;
        coordinates: number[][];
    };
    static validate(multiPoint: ISerializedMultiPoint): boolean;
    get _internalType(): import("../utils/symbol").InternalSymbol;
}
