import { DocumentReference } from './document';
import { Query } from './query';
import Aggregation from './aggregate';
import { CreateIndexRes, DropIndexRes, ListIndexesRes } from './result-types';
/**
 * 集合模块，继承 Query 模块
 *
 */
export declare class CollectionReference extends Query {
    /**
     * 读取集合名字
     */
    get name(): string;
    /**
     * 获取文档的引用
     *
     * @param docID - 文档 ID
     */
    doc(docID: string | number): DocumentReference;
    /**
     * 添加一篇文档
     *
     * @param data - 数据
     */
    add(data: object, options?: {
        multi: boolean;
    }): Promise<import("./result-types").AddRes>;
    aggregate(rawPipeline?: object[]): Aggregation;
    /**
     * 创建索引
     */
    createIndex(keys: Record<string, number | string>, options?: any): Promise<CreateIndexRes>;
    /**
     * 删除索引
     */
    dropIndex(index: string | Record<string, number | string>): Promise<DropIndexRes>;
    listIndexes(): Promise<ListIndexesRes>;
}
