import { LineString } from './lineString';
import { ISerializedMultiLineString } from './interface';
/**
 * 多个 LineString
 *
 * @author starkewang
 */
export declare class MultiLineString {
    readonly lines: LineString[];
    /**
     * 初始化
     *
     * @param lines    - LineString
     */
    constructor(lines: LineString[]);
    parse(key: any): {
        [x: number]: {
            type: string;
            coordinates: number[][][];
        };
    };
    toJSON(): {
        type: string;
        coordinates: number[][][];
    };
    static validate(multiLineString: ISerializedMultiLineString): boolean;
    get _internalType(): import("../utils/symbol").InternalSymbol;
}
