import { ISerializedPoint } from './interface';
/**
 * 地址位置
 *
 * @author haroldhu
 */
export declare class Point {
    /**
     * 纬度
     * [-90, 90]
     */
    readonly latitude: number;
    /**
     * 经度
     * [-180, 180]
     */
    readonly longitude: number;
    /**
     * 初始化
     *
     * @param latitude    - 纬度 [-90, 90]
     * @param longitude   - 经度 [-180, 180]
     */
    constructor(longitude: number, latitude: number);
    parse(key: any): {
        [x: number]: {
            type: string;
            coordinates: number[];
        };
    };
    toJSON(): {
        type: string;
        coordinates: number[];
    };
    toReadableString(): string;
    static validate(point: ISerializedPoint): boolean;
    get _internalType(): import("../utils/symbol").InternalSymbol;
}
